SpyBara
Go Premium

go/resources/completions/methods/create/index.md 2026-07-10 23:02 UTC to 2026-07-12 06:58 UTC

3 added, 1 removed.

2026
Fri 31 21:03 Thu 30 23:58 Wed 29 15:02 Sat 25 05:59 Thu 23 18:00 Wed 22 20:02 Mon 20 20:00 Fri 17 17:00 Thu 16 20:57 Wed 15 02:58 Tue 14 06:58 Mon 13 15:59 Sun 12 06:58 Fri 10 23:02 Thu 9 20:58 Tue 7 08:02

Create completion

client.Completions.New(ctx, body) (*Completion, error)

post /completions

Creates a completion for the provided prompt and parameters.

Returns a completion object, or a sequence of completion objects if the request is streamed.

Parameters

  • body CompletionNewParams

    • Model param.Field[CompletionNewParamsModel]

      ID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.

      • string

      • CompletionNewParamsModel

        • const CompletionNewParamsModelGPT3_5TurboInstruct CompletionNewParamsModel = "gpt-3.5-turbo-instruct"

        • const CompletionNewParamsModelDavinci002 CompletionNewParamsModel = "davinci-002"

        • const CompletionNewParamsModelBabbage002 CompletionNewParamsModel = "babbage-002"

    • Prompt param.Field[CompletionNewParamsPromptUnion]

      The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays.

      Note that <|endoftext|> is the document separator that the model sees during training, so if a prompt is not specified the model will generate as if from the beginning of a new document.

      • string

      • []string

      • []int64

      • [][]int64

    • BestOf param.Field[int64]

      Generates best_of completions server-side and returns the "best" (the one with the highest log probability per token). Results cannot be streamed.

      When used with n, best_of controls the number of candidate completions and n specifies how many to return – best_of must be greater than n.

      Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop.

    • Echo param.Field[bool]

      Echo back the prompt in addition to the completion

    • FrequencyPenalty param.Field[float64]

      Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

      See more information about frequency and presence penalties.

    • LogitBias param.Field[map[string, int64]]

      Modify the likelihood of specified tokens appearing in the completion.

      Accepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. You can use this tokenizer tool to convert text to token IDs. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.

      As an example, you can pass {"50256": -100} to prevent the <|endoftext|> token from being generated.

    • Logprobs param.Field[int64]

      Include the log probabilities on the logprobs most likely output tokens, as well the chosen tokens. For example, if logprobs is 5, the API will return a list of the 5 most likely tokens. The API will always return the logprob of the sampled token, so there may be up to logprobs+1 elements in the response.

      The maximum value for logprobs is 5.

    • MaxTokens param.Field[int64]

      The maximum number of tokens that can be generated in the completion.

      The token count of your prompt plus max_tokens cannot exceed the model's context length. Example Python code for counting tokens.

    • N param.Field[int64]

      How many completions to generate for each prompt.

      Note: Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for max_tokens and stop.

    • PresencePenalty param.Field[float64]

      Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

      See more information about frequency and presence penalties.

    • Seed param.Field[int64]

      If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result.

      Determinism is not guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend.

    • Stop param.Field[CompletionNewParamsStopUnion]

      Not supported with latest reasoning models o3 and o4-mini.

      Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.

      • string

      • []string

    • ``

    • StreamOptions param.Field[ChatCompletionStreamOptions]

      Options for streaming response. Only set this when you set stream: true.

    • Suffix param.Field[string]

      The suffix that comes after a completion of inserted text.

      This parameter is only supported for gpt-3.5-turbo-instruct.

    • Temperature param.Field[float64]

      What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.

      We generally recommend altering this or top_p but not both.

    • TopP param.Field[float64]

      An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

      We generally recommend altering this or temperature but not both.

    • User param.Field[string]

      A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more.

Returns

  • type Completion struct{…}

    Represents a completion response from the API. Note: both the streamed and non-streamed response objects share the same shape (unlike the chat endpoint).

    • ID string

      A unique identifier for the completion.

    • Choices []CompletionChoice

      The list of completion choices the model generated for the input prompt.

      • FinishReason CompletionChoiceFinishReason

        The reason the model stopped generating tokens. This will be stop if the model hit a natural stop point or a provided stop sequence, length if the maximum number of tokens specified in the request was reached, or content_filter if content was omitted due to a flag from our content filters.

        • const CompletionChoiceFinishReasonStop CompletionChoiceFinishReason = "stop"

        • const CompletionChoiceFinishReasonLength CompletionChoiceFinishReason = "length"

        • const CompletionChoiceFinishReasonContentFilter CompletionChoiceFinishReason = "content_filter"

      • Index int64

      • Logprobs CompletionChoiceLogprobs

        • TextOffset []int64

        • TokenLogprobs []float64

        • Tokens []string

        • TopLogprobs []map[string, float64]

      • Text string

    • Created int64

      The Unix timestamp (in seconds) of when the completion was created.

    • Model string

      The model used for completion.

    • Object TextCompletion

      The object type, which is always "text_completion"

      • const TextCompletionTextCompletion TextCompletion = "text_completion"
    • SystemFingerprint string

      This fingerprint represents the backend configuration that the model runs with.

      Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism.

    • Usage CompletionUsage

      Usage statistics for the completion request.

      • CompletionTokens int64

        Number of tokens in the generated completion.

      • PromptTokens int64

        Number of tokens in the prompt.

      • TotalTokens int64

        Total number of tokens used in the request (prompt + completion).

      • CompletionTokensDetails CompletionUsageCompletionTokensDetails

        Breakdown of tokens used in a completion.

        • AcceptedPredictionTokens int64

          When using Predicted Outputs, the number of tokens in the prediction that appeared in the completion.

        • AudioTokens int64

          Audio input tokens generated by the model.

        • ReasoningTokens int64

          Tokens generated by the model for reasoning.

        • RejectedPredictionTokens int64

          When using Predicted Outputs, the number of tokens in the prediction that did not appear in the completion. However, like reasoning tokens, these tokens are still counted in the total completion tokens for purposes of billing, output, and context window limits.

      • PromptTokensDetails CompletionUsagePromptTokensDetails

        Breakdown of tokens used in the prompt.

        • AudioTokens int64

          Audio input tokens present in the prompt.

        • CacheWriteTokens int64

          The unadjusted number of prompt tokens written to cache.

        • CachedTokens int64

          Cached tokens present in the prompt.

Example

package main

import (
  "context"
  "fmt"

  "github.com/openai/openai-go"
  "github.com/openai/openai-go/option"
)

func main() {
  client := openai.NewClient(
    option.WithAPIKey("My API Key"),
  )
  completion, err := client.Completions.New(context.TODO(), openai.CompletionNewParams{
    Model: openai.CompletionNewParamsModelGPT3_5TurboInstruct,
    Prompt: openai.CompletionNewParamsPromptUnion{
      OfString: openai.String("This is a test."),
    },
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", completion)
}

Response

{
  "id": "id",
  "choices": [
    {
      "finish_reason": "stop",
      "index": 0,
      "logprobs": {
        "text_offset": [
          0
        ],
        "token_logprobs": [
          0
        ],
        "tokens": [
          "string"
        ],
        "top_logprobs": [
          {
            "foo": 0
          }
        ]
      },
      "text": "text"
    }
  ],
  "created": 0,
  "model": "model",
  "object": "text_completion",
  "system_fingerprint": "system_fingerprint",
  "usage": {
    "completion_tokens": 0,
    "prompt_tokens": 0,
    "total_tokens": 0,
    "completion_tokens_details": {
      "accepted_prediction_tokens": 0,
      "audio_tokens": 0,
      "reasoning_tokens": 0,
      "rejected_prediction_tokens": 0
    },
    "prompt_tokens_details": {
      "audio_tokens": 0,
      "cache_write_tokens": 0,
      "cached_tokens": 0
    }
  }
}